#include "hls_stream.h"
#include "ap_axi_sdata.h"

void sideband( hls::stream<ap_axis<32,1,1,1> >& a,
               hls::stream<ap_axis<32,1,1,1> >& b ){
#pragma HLS INTERFACE axis port=a
#pragma HLS INTERFACE axis port=b

  ap_axis<32,1,1,1> aa, bb;
  int sum=0, i=0, ma, mi;
  
  do {
    aa = a.read();
    int x = aa.data.to_int();
    if (i==0){ ma=x; mi=x; }
    if (i!=0 && ma<x) ma=x;
    if (i!=0 && mi>x) mi=x;
    sum += x;
    i ++;
  } while(aa.last == 0);

  bb.data = sum;  bb.last = 0;  b.write(bb);
  bb.data = ma;   bb.last = 0;  b.write(bb);
  bb.data = mi;   bb.last = 1;  b.write(bb);
}

void stream_ex( hls::stream<int>& a,
                hls::stream<int>& b ){
#pragma HLS INTERFACE axis port=a
#pragma HLS INTERFACE axis port=b
  int sum=0, ma, mi;
  for (int i=0; i<10; i++){
    int x = a.read();
    if (i==0){ ma=x; mi=x; }
    if (i!=0 && ma<x) ma=x;
    if (i!=0 && mi>x) mi=x;
    sum += x;
  }

  b.write(sum); b.write(ma); b.write(mi);
}

struct int_s{
  int data;
  bool last;
};

void sideband_simple(hls::stream<int_s>& a, 
                     hls::stream<int_s>& b){
#pragma HLS INTERFACE axis port=a
#pragma HLS INTERFACE axis port=b

  int_s aa, bb;
  int sum=0, i=0, ma, mi;
  
  do {
    aa = a.read();
    int x = aa.data;
    if (i==0){ ma=x; mi=x; }
    if (i!=0 && ma<x) ma=x;
    if (i!=0 && mi>x) mi=x;
    sum += x;
    i ++;
  } while(aa.last == 0);

  bb.data = sum;  bb.last = 0;  b.write(bb);
  bb.data = ma;   bb.last = 0;  b.write(bb);
  bb.data = mi;   bb.last = 1;  b.write(bb);
}
